/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
/* Header file */
#include "js-utils.h"
#include "js-scriptruntime.h"
#include "js-functionobject.h"

/* Class data */
const jsString_t JSFunctionObject::className = "JSFunctionObject";

/* Procedures */
void JSFunctionObject::setLength(short length)
{
    lengthPropertyValue = length;
}
void JSFunctionObject::setParmsLength(short length)
{
    parmsLength = length;
}
jsBool_t JSFunctionObject::isInstanceOf(const jsString_t className)
{
    if (className == JSFunctionObject::className)
        return TRUE;
    return JSNativeFunction::isInstanceOf(className);
}

jsBool_t JSFunctionObject::has(JSContext * cx, jsString_t name, JSScriptable * start)
{
    return (strcmp(name, "length") == 0 || JSNativeFunction::has(cx, name, start)
            );
}

jsBool_t JSFunctionObject::get(JSContext * cx, jsString_t name, JSScriptable * start, jsVal_t * value)
{
    if (strcmp(name, "length") == 0) {
        *value = JSScriptRuntime::toValue(cx, (int)lengthPropertyValue);
        return TRUE;
    }
    return JSNativeFunction::get(cx, name, start, value);
}

void JSFunctionObject::put(JSContext * cx, jsString_t name, JSScriptable * start, jsVal_t value)
{
    if (strcmp(name, "length") != 0) {
        JSNativeFunction::put(cx, name, start, value);
    }
}
void JSFunctionObject::addAsConstructor(JSContext * cx, JSScriptable * scope, JSScriptable * prototype)
{
    setParentScope(cx, scope);
    setPrototype(cx, getFunctionPrototype(cx, scope));
    prototype->setParentScope(cx, this);

    const int attr = JS_PA_DontEnum | JS_PA_Permanent | JS_PA_ReadOnly;

    defineProperty(cx, "prototype", JS_OBJECT_TO_VAL(prototype), attr);

    jsString_t name = prototype->getClassName(cx);

    if (strcmp(name, "With") != 0) {
        if (prototype->isInstanceOf(JSScriptableObject::className)) {
            ((JSScriptableObject *) prototype)
                    ->defineProperty(cx, "constructor", JS_OBJECT_TO_VAL(this), attr);
        }
        else {
            prototype->put(cx, "constructor", prototype, JS_OBJECT_TO_VAL(this));
        }
    }
    if (scope->isInstanceOf(JSScriptableObject::className)) {
        ((JSScriptableObject *) scope)
                ->defineProperty(cx, name, JS_OBJECT_TO_VAL(this), JS_PA_DontEnum);
    }
    else {
        scope->put(cx, name, scope, JS_OBJECT_TO_VAL(this));
    }
    setParentScope(cx, scope);
}

JSFunctionObject::JSFunctionObject(JSContext * cx, jsString_t name, jsString_t clazz, JSScriptable * scope)
{
    this->names = (jsString_t *) JS_NewGCObj(cx, sizeof(*this->names));
    this->names[0] = JS_NewGCString(cx, name);
    this->namesLength = 1;
    this->clazz = clazz;
    parmsLength = 0;
    lengthPropertyValue = 1;
    argCount = 0;

    setParentScope(cx, scope);
    setPrototype(cx, getFunctionPrototype(cx, scope));
    useDynamicScope = cx->hasCompileFunctionsWithDynamicScope();
}
